'use strict';

var GAUGERADIUS = 38;

var Dashboard = function(){
    var vars = {
            svg : '',
            $svg : '',
            $dashboard : '',

            dashboardInterval: {},
            dbg: true
        },

    // _____  ________      _______ _____ ______   _    _ _____   _____
    // |  __ \|  ____\ \    / /_   _/ ____|  ____| | |  | |  __ \ / ____|
    // | |  | | |__   \ \  / /  | || |    | |__    | |  | | |__) | (___
    // | |  | |  __|   \ \/ /   | || |    |  __|   | |  | |  ___/ \___ \
    // | |__| | |____   \  /   _| || |____| |____  | |__| | |     ____) |
    // |_____/|______|   \/   |_____\_____|______|  \____/|_|    |_____/

        setUPSStatus = function setStatus(status){
                var oldState = vars.$svg.attr('class'),
                    prefix = "status-",
                    classList = [],
                    newState;

                if(!lunar.hasClass(vars.svg, prefix+status)){
                    if(oldState === undefined){
                        classList = [];
                    }else{
                        classList = oldState.split(" ");
                        _.remove(classList, function(o) {return o.indexOf(prefix) > -1; });
                    }

                    classList.push(prefix+status);
                    newState = classList.join(" ");

                    vars.$svg.attr('class', newState);
                }
            },

        setUPSio_type = function setUPSio_type(type){
            var classes = vars.$svg.attr('class'),
                classList, newClasses;

            if(!lunar.hasClass(vars.svg, Config.get("upsTypemap")[type])){
                if(classes === undefined){
                    classList = [];
                }else{
                    classList = classes.split(" ");
                    _.remove(classList, function(o) {return (o == "online" || o == "lineinteractive"); });
                }

                classList.push(Config.get("upsTypemap")[type]);
                newClasses = classList.join(" ");

                vars.$svg.attr('class', newClasses);
            }
        },

        setUPSIconsColor = function(conf){
            vars.$svg.find(".icons .icon_battery").find(".icon_outline").css("fill", conf.battery_color);
            vars.$svg.find(".icons .icon_bypass").find(".icon_outline").css("fill", conf.bypass_color);
            vars.$svg.find(".icons .icon_input").find(".icon_outline").css("fill", conf.input_color);
            vars.$svg.find(".icons .icon_output").find(".icon_outline").css("fill", conf.output_color);
            vars.$svg.find(".icons .icon_system").find(".icon_outline").css("fill", conf.system_color);
        },

        drawPie = function( group, cx, cy, load){
            var txt = group.find(".value");
            if (isNaN(load))
                load = 0;
            txt.empty().append(load + "%");

            var path = group.find(".pie_value");
            // verifica limiti valore load
            if( load < 0 )
                load = 0;
            if( load > 125 )
            {
                // colore rosso
                path.css("fill", "#EE1C25");
                load = 100;
            }
            else if( load > 100 )
            {
                // colore arancione
                path.css("fill", "#F79432");
                load = 100;
            }
            else
            {
                // colore celeste
                path.css("fill", "#00aef7");
            }
            var alpha = load * 2;
            var startX, startY, endX, endY;
            startX = cx + GAUGERADIUS * Math.cos( -200/180 * Math.PI );
            startY = cy + GAUGERADIUS * Math.sin( -200/180 * Math.PI );
            endX = cx + GAUGERADIUS * Math.cos( (-200+alpha)/180 * Math.PI );
            endY = cy + GAUGERADIUS * Math.sin( (-200+alpha)/180 * Math.PI );
            if( alpha <= 20 )
                path.attr("d", "M " + cx + "," + cy + " " + startX + "," + startY + " A " + GAUGERADIUS + "," + GAUGERADIUS + " 0 0 1 " + endX + "," + endY);
            else
                path.attr("d", "M " + cx + "," + cy + " " + startX + "," + startY + " A " + GAUGERADIUS + "," + GAUGERADIUS + " 0 0 1 " + (cx-GAUGERADIUS) + "," + cy + " A " + GAUGERADIUS + "," + GAUGERADIUS + " 0 0 1 " + endX + "," + endY);
        },

        setGaugeValue = function(v){
            var group;
            group = vars.$svg.find(".gauges .gauge_Load1");
            drawPie(group, 753, 357, v.load1);
            group = vars.$svg.find(".gauges .gauge_Load2");
            drawPie(group, 753, 417, v.load2);
            group = vars.$svg.find(".gauges .gauge_Load3");
            drawPie(group, 753, 477, v.load3);
            group = vars.$svg.find(".gauges .gauge_Charge");
            drawPie(group, 353, 426, v.batcap);
        },

        updateUPSVariables = function(v){
            //input section
            vars.$dashboard.find(".vin1").html(v.vin1);
            vars.$dashboard.find(".vin2").html(v.vin2);
            vars.$dashboard.find(".vin3").html(v.vin3);

            vars.$dashboard.find(".load1").html(v.load1);
            vars.$dashboard.find(".load2").html(v.load2);
            vars.$dashboard.find(".load3").html(v.load3);

            //battery section
            vars.$dashboard.find(".autonomy").html( minToHHMM(v.authonomy) );
            vars.$dashboard.find(".batcap").html( v.batcap );
        },

    //  _____  ________      _______ _____ ______   __  __ _____  _    _
    // |  __ \|  ____\ \    / /_   _/ ____|  ____| |  \/  |  __ \| |  | |
    // | |  | | |__   \ \  / /  | || |    | |__    | \  / | |  | | |  | |
    // | |  | |  __|   \ \/ /   | || |    |  __|   | |\/| | |  | | |  | |
    // | |__| | |____   \  /   _| || |____| |____  | |  | | |__| | |__| |
    // |_____/|______|   \/   |_____\_____|______| |_|  |_|_____/ \____/

        setMDUStatus = function setMDUStatus(output_n, path_n, status){

            // legenda caratteri di stato uscite:
            // 0 - output OFF no line
            // 1 - output ON line
            // 2 - shutdown active
            // 3 - shutdown imminent
            // 4 - restore active
            // 5 - overload alarm
            // 6 - lock
            //   $state-normal: #00ADEE;
            //   $state-bypass: #003875;
            //   $state-danger: #f00;
            //   $state-warning: #F28E39;

            var colorfill;
            switch (status) {
                case 0:
                    colorfill = "#A7A7A7";
                    break;
                case 1:
                    colorfill = "#00ADEE";
                    break;
                case 2:
                case 3:
                case 4:
                    colorfill = "#F28E39";
                    break;
                case 5:
                case 6:
                    colorfill = "#FF0000";
                    break;
            }
            _.forEach(vars.$svg.find(".paths path"), function(path){
                if (path.id == path_n ){
                    var len = path.getTotalLength();
                    if (status==0){
                        path.style['stroke-dashoffset'] = len+"px";
                    }
                    else{
                        path.style['stroke-dashoffset'] = 0+"px";
                    }
                }
            });

            vars.$dashboard.find(output_n).find(".icon_outline").css("fill", colorfill);

        },

        setMDUIconsColor = function(conf){
            vars.$dashboard.find(".icons .icon_input").find(".icon_outline").css("fill", conf.input_color);
            vars.$dashboard.find(".icons .icon_system").find(".icon_outline").css("fill", conf.system_color);

            var sourceLine = vars.$dashboard.find("#input_system");
            sourceLine.css("stroke", conf.input_color);
            sourceLine.css("stroke-dashoffset", 0+"px");
        },

        updateMDUVariables = function(v){
            //input section
            vars.$dashboard.find(".vin").html(v.vin);
            vars.$dashboard.find(".ain").html(fixedValue(v.ain / 10, 1));
            vars.$dashboard.find(".fin").html(fixedValue(v.fin / 10, 1));
        },

    //  _____  ________      _______ _____ ______    _____ _______ _____
    // |  __ \|  ____\ \    / /_   _/ ____|  ____|  / ____|__   __/ ____|
    // | |  | | |__   \ \  / /  | || |    | |__    | (___    | | | (___
    // | |  | |  __|   \ \/ /   | || |    |  __|    \___ \   | |  \___ \
    // | |__| | |____   \  /   _| || |____| |____   ____) |  | |  ____) |
    // |_____/|______|   \/   |_____\_____|______| |_____/   |_| |_____/

        setSTSStatus = function setSTSStatus(icon_n, path_n, color){

            _.forEach(vars.$svg.find(".paths path"), function(path){
                if (path.id == path_n ) {
                    var len = path.getTotalLength();
                    if (color==0){
                        path.style['stroke-dashoffset'] = len+"px";
                    }
                    else{
                        path.style['stroke-dashoffset'] = 0+"px";
                    }
                    path.style['stroke'] = color;
                }
            });

            vars.$dashboard.find(icon_n).find(".icon_outline").css("fill", color);
        },

        setSTSSwitchStatus = function(path_n, status){
            var path = vars.$svg.find(".icons").find(path_n).find(".switch_contact");

            if (status == 1)
                path.css("stroke", "#000000");
            else
                path.css("stroke", "none");
        },

        updateSTSVariables = function(v){
            //input section
            vars.$dashboard.find(".vin1s1").html(v.vin1s1);
            vars.$dashboard.find(".vin2s1").html(v.vin2s1);
            vars.$dashboard.find(".vin3s1").html(v.vin3s1);

            vars.$dashboard.find(".vin1s2").html(v.vin1s2);
            vars.$dashboard.find(".vin2s2").html(v.vin2s2);
            vars.$dashboard.find(".vin3s2").html(v.vin3s2);

            //output section
            vars.$dashboard.find(".load1").html(v.load1);
            vars.$dashboard.find(".load2").html(v.load2);
            vars.$dashboard.find(".load3").html(v.load3);
        },

    //  _____  ________      _______ _____ ______   _____ _____  __  __  _____
    // |  __ \|  ____\ \    / /_   _/ ____|  ____| |_   _|  __ \|  \/  |/ ____|
    // | |  | | |__   \ \  / /  | || |    | |__      | | | |__) | \  / | (___
    // | |  | |  __|   \ \/ /   | || |    |  __|     | | |  _  /| |\/| |\___ \
    // | |__| | |____   \  /   _| || |____| |____   _| |_| | \ \| |  | |____) |
    // |_____/|______|   \/   |_____\_____|______| |_____|_|  \_\_|  |_|_____/

        setIRMSStatus = function setIRMSStatus(output_n, path_n, sourcecolor_n, status){

            // legenda caratteri di stato uscite:
            // 0 - output OFF no line
            // 1 - output ON line
            // 2 - shutdown active
            // 3 - shutdown imminent
            // 4 - restore active
            // 5 - overload alarm
            // 6 - lock
            //   $state-normal: #00ADEE;
            //   $state-bypass: #003875;
            //   $state-danger: #f00;
            //   $state-warning: #F28E39;

            var colorfill;
            switch (status) {
                case 0:
                    colorfill = "#A7A7A7";
                    break;
                case 1:
                    colorfill = sourcecolor_n;
                    break;
                case 2:
                case 3:
                case 4:
                    colorfill = "#F28E39";
                    break;
                case 5:
                case 6:
                    colorfill = "#FF0000";
                    break;
            }
            _.forEach(vars.$svg.find(".paths path"), function(path){
                if (path.id == path_n ){
                    var len = path.getTotalLength();
                    if (status==0){
                        path.style['stroke-dashoffset'] = len+"px";
                    }
                    else{
                        path.style['stroke-dashoffset'] = 0+"px";
                    }
                    path.style['stroke'] = sourcecolor_n;
                }
            });

            vars.$dashboard.find(output_n).find(".icon_outline").css("fill", colorfill);

        },

        setIRMSIconsColor = function(conf){
            vars.$dashboard.find(".icons .icon_input1").find(".icon_outline").css("fill", conf.source1_color);
            vars.$dashboard.find(".icons .icon_system1").find(".icon_outline").css("fill", conf.system1_color);
            vars.$dashboard.find(".icons .icon_input2").find(".icon_outline").css("fill", conf.source2_color);
            vars.$dashboard.find(".icons .icon_system2").find(".icon_outline").css("fill", conf.system2_color);

            var source1Line = vars.$dashboard.find("#input_system1");
            source1Line.css("stroke", conf.source1_color);
            source1Line.css("stroke-dashoffset", 0+"px");
            var source1_outLine = vars.$dashboard.find("#system1_out");
            source1_outLine.css("fill", conf.system1_color);
            var source2Line = vars.$dashboard.find("#input_system2");
            source2Line.css("stroke", conf.source2_color);
            source2Line.css("stroke-dashoffset", 0+"px");
            var source2_outLine = vars.$dashboard.find("#system2_out");
            source2_outLine.css("fill", conf.system2_color);
        },

        updateIRMSVariables = function(v){
            //input section
            vars.$dashboard.find(".vin1s1").html(v.vin1s1);
            vars.$dashboard.find(".vin1s2").html(v.vin1s2);

            //output section
            vars.$dashboard.find(".load1").html(v.load1);
            vars.$dashboard.find(".load2").html(v.load2);
            vars.$dashboard.find(".load3").html(v.load3);
            vars.$dashboard.find(".load4").html(v.load4);
            vars.$dashboard.find(".load5").html(v.load5);
            vars.$dashboard.find(".load6").html(v.load6);
            vars.$dashboard.find(".load7").html(v.load7);
            vars.$dashboard.find(".load8").html(v.load8);
        },


        clearIntervals = function clearIntervals(){
            window.clearInterval(vars.dashboardInterval);
        },

    // ---- TEST FUNCTIONS ----

        showcase = function showcase(status){
            Main.clearIntervals();

            if(status === undefined){
                vars.dashboardInterval = window.setInterval(function(){
                    setUPSStatus(Math.floor(Math.random()*6));
                },3000);
            }else{
                setUPSStatus(status);
            }
        },
    // ----- Init -----

        init = function init() {

            //Main.updateViews();

            if ( !($("#dashboard-UPS").hasClass("hidden"))) {
                vars.svg = document.getElementById("svg-UPS");
                vars.$svg = $("#svg-UPS");
                vars.$dashboard = $("#dashboard-UPS");
            }
            else if ( !($("#dashboard-MDU").hasClass("hidden"))) {
                vars.svg = document.getElementById("svg-MDU");
                vars.$svg = $("#svg-MDU");
                vars.$dashboard = $("#dashboard-MDU");
            }
            else if (!$("#dashboard-STS").hasClass("hidden")) {
                vars.svg = document.getElementById("svg-STS");
                vars.$svg = $("#svg-STS");
                vars.$dashboard = $("#dashboard-STS");
            }
            else if (!$("#dashboard-IRMS").hasClass("hidden")) {
                vars.svg = document.getElementById("svg-IRMS");
                vars.$svg = $("#svg-IRMS");
                vars.$dashboard = $("#dashboard-IRMS");
            }
            else if (!$("#dashboard-MPW").hasClass("hidden")) {
                vars.svg = document.getElementById("svg-MPW");
                vars.$svg = $("#svg-MPW");
                vars.$dashboard = $("#dashboard-MPW");
            }
            else if (!$("#dashboard-unknown").hasClass("hidden")) {
                vars.svg = document.getElementById("svg-unknown");
                vars.$svg = $("#svg-unknown");
                vars.$dashboard = $("#dashboard-unknown");
            }


            //check svg support
            // for each path in the "paths" group (<g class="paths"> in the svg), get its totalLenght
            // and set it as stroke-dasharray and stroke-dashoffset for the animations
            _.forEach(vars.$svg.find(".paths path"), function(path){
                var len = path.getTotalLength();
                path.style['stroke-dasharray'] = len+"px";
                path.style['stroke-dashoffset'] = len+"px";
            });

            //add animate class after 1 second to avoid initial animation
            setTimeout( function(){ lunar.addClass(vars.svg, 'animate'); } ,1000);
        };

    return {
        init: function(){ init(); },
        showcase: showcase,
        setUPSStatus: setUPSStatus,
        setUPSio_type: setUPSio_type,
        updateUPSVariables: updateUPSVariables,
        setUPSIconsColor : setUPSIconsColor,
        setGaugeValue : setGaugeValue,

        setMDUStatus: setMDUStatus,
        updateMDUVariables: updateMDUVariables,
        setMDUIconsColor : setMDUIconsColor,

        setSTSStatus: setSTSStatus,
        updateSTSVariables: updateSTSVariables,
        setSTSSwitchStatus : setSTSSwitchStatus,

        setIRMSStatus: setIRMSStatus,
        updateIRMSVariables: updateIRMSVariables,
        setIRMSIconsColor : setIRMSIconsColor,

        clearIntervals: clearIntervals
    }
}();
